; Read number from keyboard
; (C) 2006, Andreas Berg. All Rights Reserved.

; This example reads a number string from keyboard,
; converts it to a number [val], and then convert back to
; a string again.

; Set Up EXE
.model small
.stack 100h

; Data Segment
.data
pageNum       db 0                     ; Video page
strLen        db 0                     ; String Length
chr           db 0                     ; Current character
val           dw 0                     ; Value (converted from string)
m             dw 1                     ; Multiply value
inputStr      array byte 0,6           ; Input string
resStr        array byte 0,6           ; Result string

; Messages
cr            db 13,10,"$"
iMsg          db 13,10,"Input number: $"
rMsg          db 13,10,"Result: $"

; Code Segment
.code
start:
mov           ax,@data                 ; AX = @DATA
mov           ds,ax                    ; DS = AX

; Read Video page
mov           ah,0fh                   ; AH = 0Fh (Function #)
int           10h                      ; INT 10: Get Video Info
mov           [pageNum],bh             ; [pageNum] = BH

; Input String
mov           dx,offset iMsg           ; DX -> iMsg
mov           ah,9                     ; AH = 9 (Function #)
int           21h                      ; INT 21h: Write String

mov           di,offset inputStr       ; DI -> inputStr

gChr:
cmp           byte [strLen],4          ; Check if longer than 4 characters
je            endChr                   ; If yes, stop read

xor           ax,ax                    ; AH = 0 (Function #)
int           16h                      ; INT 16h: Read Key
mov           [chr],al                 ; Store ASCII in [chr]

cmp           byte [chr],13            ; Press <ENTER>?
je            endChr                   ; If yes, stop read

cmp           byte [chr],"0"           ; If >= "0"?
jl            gChr                     ; If no, try again

cmp           byte [chr],"9"           ; If <= "9"?
jg            gChr                     ; If no, try again

mov           ah,0eh                   ; AH = 0Eh (Function #)
mov           al,[chr]                 ; AL = [chr]
mov           bh,[pageNum]             ; BH = [pageNum]
int           10h                      ; INT 10h: Write Character

mov           al,[chr]                 ; AL = [chr]
mov           byte ptr [di],al         ; inputStr[DI] = AL
inc           di                       ; DI++
inc           byte [strLen]            ; strLen++
jmp           gChr                     ; Read next character
endChr:
mov           byte ptr [di],"$"        ; inputStr[DI] = "$"
mov           dx,offset cr             ; DX -> cr
mov           ah,9                     ; AH = 9 (Function #)
int           21h                      ; INT 21h: Write String

; Convert String to number
cmp           byte [strLen],0          ; Any characters to convert?
je            endConv                  ; If no, skip convert

mov           si,inputStr              ; SI -> inputStr
xor           ax,ax                    ; AX = 0
mov           al,[strLen]              ; AL = [strLen]
add           si,ax                    ; SI = SI + AX
dec           si                       ; SI--

doConv:
xor           cx,cx                    ; CX = 0
mov           cl,byte ptr [si]         ; CL = [SI]
sub           cl,"0"                   ; Remove "0"
mov           ax,[m]                   ; AX = [m]
mul           cx                       ; Multiply CX*AX
add           [val],ax                 ; Add result to [val]

mov           ax,10                    ; AX = 10
mul           word [m]                 ; Multiply [m]*AX
mov           [m],ax                   ; [m] = AX

dec           si                       ; SI--

cmp           byte [strLen],1          ; [strLen = 1]?
je            endConv                  ; If yes, stop converting
dec           byte [strLen]            ; [strLen]--
jmp           doConv                   ; Handle next number
endConv:


; *** [val] = convertertd string value !!! ***


; Convert back to new string  :-)
cmp           word [val],0             ; Value = 0?
je            set0                     ; Set string to "0"

mov           di,offset resStr         ; DI -> resStr
mov           ax,[val]                 ; AX = [val]
mov           cx,10                    ; DX = 10

; (adjust pointer)
cmp           word [val],10000         ; Is 5 digits?
jl            is1000                   ; It's less, check if 4
add           di,5                     ; DI +5
mov           byte ptr [di],"$"
dec           di
jmp           convStr                  ; Convert to string

is1000:
cmp           word [val],1000          ; Is 4 digits?
jl            is100                    ; It's less, check if 3
add           di,4                     ; DI +4
mov           byte ptr [di],"$"
dec           di
jmp           convStr                  ; Convert to string

is100:
cmp           word [val],100           ; Is 3 digits?
jl            is10                     ; It's less, check if 2
add           di,3                     ; DI +3
mov           byte ptr [di],"$"
dec           di
jmp           convStr                  ; Convert to string

is10:
cmp           word [val],10            ; IF 2 digits?
jl            is1                      ; It's less, set to 1  :-)
add           di,2                     ; DI +2
mov           byte ptr [di],"$" 
dec           di
jmp           convStr                  ; Convert to string

is1:
inc           di                       ; DI++
mov           byte ptr [di],"$"
dec           di                       ; DI--
jmp           convStr                  ; Convert to string

set0:
mov           di,offset resStr         ; DI -> resStr
mov           byte ptr [di],"0"        ; resStr[DI] = "0"
inc           di                       ; DI++
mov           byte ptr [di],"$"        ; resStr[DI] = "$"
jmp           writeRes                 ; Write result

convStr:
cmp           ax,0                     ; AX = 0? (last digit ?)
je            endConvStr               ; If yes, stop converting

xor           dx,dx                    ; DX = 0
div           cx                       ; Divide by 10
add           dx,"0"                   ; Make ASCII

mov           byte ptr [di],dl         ; resStr[DI] = Dl
dec           di                       ; DI--
jmp           convStr                  ; Next digit
endConvStr:
mov           byte ptr [di],"$"        ; resStr[DI] = "$"

; Write result
writeRes:
mov           dx,offset rMsg           ; DX -> rMsg
mov           ah,9                     ; AH = 9 (Function #)
int           21h                      ; INT 21h: Write String
mov           dx,offset resStr         ; DX -> resStr
mov           ah,9                     ; AH = 9 (Function #)
int           21h                      ; INT 21h: Write String
mov           dx,offset cr             ; DX -> cr
mov           ah,9                     ; AH = 9 (Function #)
int           21h                      ; INT 21h: Write String

; End EXE
mov           ah,4ch                   ; AH = 4Ch (Function #)
mov           al,0                     ; AL = 0 (Exit Code)
int           21h                      ; INT 21h: Terminate EXE

end start
