{ Blasm 0.01
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
program blasm;

uses
 Crt, SysUtils, _common, _main;

var
 aFile              : string;
 iFile              : string;
 eFile              : string;
 oFile              : string;

 err, f             : boolean;
 i                  : integer;
 s                  : string;


begin
   write(appName + ' ' + IntToStr(appVerMajor)+ '.');
   write(IntToStr(appVerMinor) + '.' + IntToStr(appVerRelease));
   writeln(' / (C) 2005-2012, Andreas Berg. All Rights Reserved.');

   if paramcount < 1 then begin
      writeln('usage:  blasm  input-file  [options]  [output-file]');
      WriteLn('');
      WriteLn('OPTION              DESCRIPTION');
      Writeln(' -i:<file>          Set Initial Data Source');
      Writeln(' -e:<file>          Set End Data Source');
      Writeln('');
   end else begin
      writeln;

      err:= false;
      aFile:= '';
      iFile:= '';
      eFile:= '';
      oFile:= '';

      for i:= 1 to ParamCount do begin
         s:= ParamStr(i);
         if s[1] = '-' then begin
            f:= false;
            if UpperCase(copy(s, 1, 3)) = '-I:' then begin
               iFile:= copy(s, 4, length(s) - 3);
               f:= true;
            end;
            if UpperCase(copy(s, 1, 3)) = '-E:' then begin
               eFile:= copy(s, 4, length(s) - 3);
               f:= true;
            end;

            if not f then begin
               Writeln('ERROR: Invalid option [' + s + ']!');
               err:= true;
            end;
         end else begin
            if aFile = '' then
             aFile:= ParamStr(i)
            else begin
               if oFile = '' then
                oFile:= ParamStr(i)
               else begin
                  Writeln('ERROR: Input and Output files already set!');
                  err:= true;
               end;
            end;
         end;
      end;

      if (aFile = '') and (not err) then begin
         Writeln('ERROR: No input file!');
         err:= true;
      end;

      if not err then begin
         StartASM(aFile, iFile, eFile, oFile);
      end;

   end;
end.
